Index: main/kofacustom.wdu/trunk/src/kofacustom/wdu/applicants/browser.py
===================================================================
--- main/kofacustom.wdu/trunk/src/kofacustom/wdu/applicants/browser.py	(revision 12887)
+++ main/kofacustom.wdu/trunk/src/kofacustom/wdu/applicants/browser.py	(revision 12888)
@@ -156,4 +156,30 @@
 
     @property
+    def note(self):
+        if self.context.sex == 'm':
+            pronoun = ('he', 'his', 'him')
+        else:
+            pronoun = ('she', 'her', 'her')
+        return ("<br /><br />The applicant has confirmed "
+                "that the passport photograph uploaded on this form is a true "
+                "picture of %s. The applicant also declared that, by submitting this form, %s wish to enter "
+                "Wester Delta University, Oghara, that the particulars given in this form are "
+                "to the best of %s knowledge and belief correct and that if admitted to the "
+                "university, %s shall regard %sself bound by the Ordinance Statutes and "
+                "Regulations of the University in so far as they affect %s. The applicant understands that "
+                "withholding any information requested or giving information may make %s "
+                "ineligable for admission, regsitration or matriculation, or compel %s "
+                "expulsion from the institution."
+                % (pronoun[2],
+                   pronoun[0],
+                   pronoun[1],
+                   pronoun[0],
+                   pronoun[2],
+                   pronoun[2],
+                   pronoun[2],
+                   pronoun[1])
+                )
+
+    @property
     def form_fields(self):
         if self.target is not None and self.target.startswith('putme'):
Index: main/kofacustom.wdu/trunk/src/kofacustom/wdu/applicants/interfaces.py
===================================================================
--- main/kofacustom.wdu/trunk/src/kofacustom/wdu/applicants/interfaces.py	(revision 12887)
+++ main/kofacustom.wdu/trunk/src/kofacustom/wdu/applicants/interfaces.py	(revision 12888)
@@ -234,4 +234,15 @@
         show_year = True,
         )
+    body_responsible_address = schema.Text(
+        title = _(u'Name and Adress of Body'),
+        description = _(
+         'Name and address of body who will be responsible for the fees. '
+         'If admission to the university is offered '
+         'a guarantor\'s form that all the fees will be paid will be sworn to '
+         'by the person or body named. The student will not be allowed into the '
+         'university until the guarantor\'s form is signed and returned '
+         'to the institution.'),
+        required = False,
+       )
     jamb_subjects = schema.Text(
         title = _(u'Subjects and Scores'),
@@ -245,8 +256,4 @@
     jamb_reg_number = schema.TextLine(
         title = _(u'JAMB Registration Number'),
-        required = False,
-        )
-    jamb_age = schema.Int(
-        title = _(u'Age (provided by JAMB)'),
         required = False,
         )
Index: main/kofacustom.wdu/trunk/src/kofacustom/wdu/applicants/tests/test_browser.py
===================================================================
--- main/kofacustom.wdu/trunk/src/kofacustom/wdu/applicants/tests/test_browser.py	(revision 12887)
+++ main/kofacustom.wdu/trunk/src/kofacustom/wdu/applicants/tests/test_browser.py	(revision 12888)
@@ -83,17 +83,21 @@
             'emp_position,emp_reason,emp_start,employer,employer2,'
             'firstname,history,hq_degree,hq_disc,hq_matric_no,hq_school,'
-            'hq_session,hq_type,jamb_age,jamb_score,jamb_subjects,lastname,lga,'
-            'locked,middlename,nationality,notice,nysc_lga,nysc_year,'
+            'hq_session,hq_type,jamb_age,jamb_reg_number,jamb_score,'
+            'jamb_subjects,lastname,lga,locked,marit_stat,middlename,'
+            'nationality,next_kin_address,notice,nysc_lga,nysc_year,'
+            'olevel_exam_date,olevel_exam_date2,olevel_exam_number,'
+            'olevel_exam_number2,olevel_results,olevel_results2,'
+            'olevel_school,olevel_school2,olevel_type,olevel_type2,'
             'password,phone,pp_school,presently_inst,reg_number,'
-            'result_uploaded,screening_date,screening_score,'
-            'screening_venue,sex,special_application,'
-            'state,student_id,suspended,container_code\r\n'
+            'religion,result_uploaded,screening_date,screening_score,'
+            'screening_venue,sex,special_application,state,student_id,'
+            'suspended,container_code\r\n'
             ',dp2011_654321,,654321,CERT1,CERT1,CERT1,1981-02-04#,'
             'Anna M. Tester,anna@sample.com,,,,,,,,,,,Anna,'
-            '[u\'2012-10-28 21:27:52 WAT - Application initialized by system\']'
-            ',,,,,,,,,,Tester,,0,M.,NG,"Some notice\nin lines.",,,'
-            'any password,+234-123-12345#,,,123456,,'
-            '"Saturday, 16th June 2012 2:00:00 PM",98,Exam Room,f,,initialized,,'
-            '0,dp2011\r\n')
+            '[u\'2015-04-26 13:44:05 WAT - Application initialized by system\']'
+            ',,,,,,,,,,,Tester,,0,,M.,NG,,"Some notice\nin lines.",,,,,,,,,,,,,'
+            'any password,+234-123-12345#,,,123456,,,'
+            '"Saturday, 16th June 2012 2:00:00 PM",98,Exam Room,'
+            'f,,initialized,,0,dp2011\r\n')
         # We can import the same file if we ignore some columns.
         # Since the applicants_catalog hasn't been notified, the same
Index: main/kofacustom.wdu/trunk/src/kofacustom/wdu/applicants/utils.py
===================================================================
--- main/kofacustom.wdu/trunk/src/kofacustom/wdu/applicants/utils.py	(revision 12887)
+++ main/kofacustom.wdu/trunk/src/kofacustom/wdu/applicants/utils.py	(revision 12888)
@@ -37,5 +37,5 @@
         'form.hq_type': _(u'Higher Education Record'),
         'form.presently': _(u'Course or Programme Presently Attending'),
-        'form.nysc_year': _(u'NYSC Information'),
+        'form.body_responsible': _(u'Fee Responsibility'),
         'form.employer': _(u'Employment History'),
         'form.jamb_subjects': _(u'JAMB Data'),
Index: main/kofacustom.wdu/trunk/src/kofacustom/wdu/locales/en/LC_MESSAGES/waeup.kofa.po
===================================================================
--- main/kofacustom.wdu/trunk/src/kofacustom/wdu/locales/en/LC_MESSAGES/waeup.kofa.po	(revision 12887)
+++ main/kofacustom.wdu/trunk/src/kofacustom/wdu/locales/en/LC_MESSAGES/waeup.kofa.po	(revision 12888)
@@ -20,6 +20,11 @@
 "picture of me."
 msgstr ""
-"I confirm that the Passport Photograph uploaded on this form is a true "
-"picture of me. I also declare that I wish to to enter Wester Delta "
-"University, Oghara, that the particulars given in this form are to the best "
-"of my knowledge ..."
+"I confirm that the passport photograph uploaded on this form is a true "
+"picture of me. I also declare that, by submitting this form, I wish to enter "
+"Wester Delta University, Oghara, that the particulars given in this form are "
+"to the best of my knowledge and belief correct and that if admitted to the "
+"university, I shall regard myself bound by the Ordinance Statutes and "
+"Regulations of the University in so far as they affect me. I understand that "
+"withholding any information requested or giving information may make me "
+"ineligable for admission, regsitration or matriculation, or compel my "
+"expulsion from the institution."